VERSION 5.00
Begin VB.Form sick 
   Caption         =   "Form1"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "sick"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'// This code was originally written by K. Sevcik to get data from SICK LMS
'// sensor.  I modified it so that it could be used for SLAM implementation
Dim VarchrBuff As Variant
Dim received() As Byte
Dim numDataPoints, j As Integer
Dim storeLSB As Long
Dim MsbLsb As Boolean
Dim detectHeader As Integer
Dim scanData As String



Sub Send()

    Dim StringHolder As String
    Dim Location As Integer
    
    StringHolder = slam.SendText.Text
    Location = InStr(2, StringHolder, "&H")
    
    If Location <> 0 Then
    Do
        slam.MSComm1.Output = Chr(Left(StringHolder, Location - 1))
        StringHolder = Right(StringHolder, Len(StringHolder) - Location + 1)
        Location = InStr(2, StringHolder, "&H")
    Loop Until (Location = 0)
    End If
    
    slam.MSComm1.Output = Chr(StringHolder)
    
End Sub

Sub saveScan()

    Dim skipByte As Integer
    Dim numScans, ExpectedDataPoints As Integer
    
    numScans = 1
    ExpectedDataPoints = 722

    Select Case slam.MSComm1.CommEvent
        Case comEvReceive
            VarchrBuff = slam.MSComm1.Input
            received() = VarchrBuff
    
            If slam.GatherData Then
                j = 0
    
                If Not (slam.BeginWrite3) Then
                    slam.ReceiveText.Text = "Searching for start of data....."
                    For j = 0 To (LenB(VarchrBuff) - 1)
                        Select Case received(j)
                            Case 2:
                                slam.BeginWrite1 = True
                            Case 128:
                                If slam.BeginWrite1 Then
                                    slam.BeginWrite2 = True
                                Else
                                    slam.BeginWrite1 = False
                                End If
                            Case 176:
                                If (slam.BeginWrite1 And slam.BeginWrite2) Then
                                    slam.BeginWrite3 = True
                                    numDataPoints = 0
                                    MsbLsb = True
                                Else
                                    slam.BeginWrite1 = False
                                    slam.BeginWrite2 = False
                                End If
                            Case Else:
                                If skipByte < 2 Then
                                    skipByte = skipByte + 1
                                Else
                                    skipByte = 0
                                    slam.BeginWrite1 = False
                                    slam.BeginWrite2 = False
                                    slam.BeginWrite3 = False
                                End If
                        End Select
                
                        If slam.BeginWrite3 Then
                            Exit For
                        End If
                    Next j
                End If
        
                If slam.BeginWrite3 Then
                    If numDataPoints = 0 Then
                        numDataPoints = received(j - 1) * 256 + received(j - 2) - 4
                        j = j + 3 '// Point to first portion of laser data
                
                        If Not (numDataPoints = ExpectedDataPoints) Then
                            slam.BeginWrite1 = False
                            slam.BeginWrite2 = False
                            slam.BeginWrite3 = False
                            slam.ReceiveText.Text = slam.ReceiveText.Text + "  Scan #" + CStr(slam.ScanCount) + "   BAD SCAN!!!"
                            GoTo badScan
                        End If
                
                        If slam.ScanCount > numScans Then
                            slam.GatherData = False
                            slam.newMove = True
                            scanData = LTrim$(scanData) '// remove space in beginning
                            Write #2, scanData
                            scanData = vbNullString
                            GoTo badScan
                        End If
                        slam.ReceiveText.Text = slam.ReceiveText.Text + "  Scan #" + CStr(slam.ScanCount) + "   Writing " + CStr(numDataPoints) + " data points....."
                        slam.ScanCount = slam.ScanCount + 1
                        'Write #2, ""
                        'Write #2, ""
                        'Write #2, ""
                        'Write #2, "Scan #" + CStr(slam.ScanCount - 1)
                
                        For i = j To (LenB(VarchrBuff) - 1)
                    
                            If MsbLsb Then
                                storeLSB = received(i)
                                MsbLsb = False
                            Else
                                'Write #2, (CLng(received(i)) * 256 + storeLSB)
                                scanData = scanData & " " & (CLng(received(i)) * 256 + storeLSB)
                                MsbLsb = True
                            End If
                    
                            numDataPoints = numDataPoints - 1
                            If numDataPoints = 0 Then
                                slam.BeginWrite1 = False
                                slam.BeginWrite2 = False
                                slam.BeginWrite3 = False
                                Exit For
                            End If
                        Next i
                    Else
                        For i = j To (LenB(VarchrBuff) - 1)
                    
                            If MsbLsb Then
                                storeLSB = received(i)
                                MsbLsb = False
                            Else
                                'Write #2, (CLng(received(i)) * 256 + storeLSB)
                                scanData = scanData & " " & (CLng(received(i)) * 256 + storeLSB)
                                MsbLsb = True
                                
                            End If
                    
                            numDataPoints = numDataPoints - 1
                            If numDataPoints = 0 Then
                                slam.BeginWrite1 = False
                                slam.BeginWrite2 = False
                                slam.BeginWrite3 = False
                                Exit For
                            End If
                        Next i
                    End If
                End If
            Else
                For i = 0 To (LenB(VarchrBuff) - 1)
                    'slam.ReceiveText.Text = slam.ReceiveText.Text + " " + Hex(received(i))
                Next i
            End If
    End Select

badScan:
    If Len(slam.ReceiveText.Text) > 1200 Then
        slam.ReceiveText.Text = ""
    End If
End Sub
